#pragma once

#include <cstddef>
#include <stdexcept>
#include <vector>

// RoundRobin Ŭ ø
// Ʈ  ҿ    κ ٸ Ѵ.
template <typename T>
class RoundRobin
{
public:
	// ȿ ̱     Ŭ̾Ʈ ޴´.
	RoundRobin(size_t numExpected = 0);
	virtual ~RoundRobin() = default;

	// ԰   Ѵ.
	RoundRobin(const RoundRobin& src) = delete;
	RoundRobin& operator=(const RoundRobin& rhs) = delete;

	// ̵ ڿ ̵  ڸ  Ʈ Ѵ.
	RoundRobin(RoundRobin&& src) = default;
	RoundRobin& operator=(RoundRobin&& rhs) = default;

	// Ҹ Ʈ  ߰Ѵ.
	// getNext() ̿ ȣ  ִ.
	void add(const T& element);

	// operator== ڸ ȣ ,
	// Ȱٰ Ǵܵ ù ° Ҹ Ѵ.
	// getNext() ̿ ȣ  ִ.
	void remove(const T& element);

	// Ʈ   Ҹ Ѵ. ù ° Һ ؼ  
	// ҿ ٴٸ ٽ ù ° ҷ ƿ´. 
	// ̶ ߰ ߰ǰų  ҵ ݿѴ.
	T& getNext();

private:
	std::vector<T> mElements;
	typename std::vector<T>::iterator mCurrentElement;
};

template <typename T>
RoundRobin<T>::RoundRobin(size_t numExpected)
{
	// Ŭ̾Ʈ  ŭ  ȮѴ.
	mElements.reserve(numExpected);

	// Ұ ּ ϳ    ʴ
	// ϴ mCurrentElement ʱȭصд.
	// there's at least one element.
	mCurrentElement = begin(mElements);
}

//  Ҵ ׻  ߰Ѵ.
template <typename T>
void RoundRobin<T>::add(const T& element)
{
	// Ҹ  ߰ϴ push_back() ȣ 
	// vector ҴǼ mCurrentElement ݺڰ ȿȭ  ִ.
	//  Ϸ ݺ  ׼  ִ ȰѴ.
	// iterator features to save our spot.
	int pos = mCurrentElement - begin(mElements);

	// Ҹ ߰Ѵ.
	mElements.push_back(element);
	
	// ݺڸ ׻ ȿ · ϵ Ѵ.
	mCurrentElement = begin(mElements) + pos;
}

template <typename T>
void RoundRobin<T>::remove(const T& element)
{
	for (auto it = begin(mElements); it != end(mElements); ++it) {
		if (*it == element) {
			// mCurrentElement ݺڰ ϴ Ұ    Ҹ
			// Ű   Ҹ ϸ mCurrentElement ݺڰ ȿȭȴ.
			//     ġ Ϸ
			// ݺ  ׼  ȰѴ.
			int newPos;

			if (mCurrentElement == end(mElements) - 1 &&
				mCurrentElement == it) {
				// mCurrentElement Ʈ  Ҹ Ű ¿
				//  Ҹ Ϸ ϹǷ ٽ ù ° ҷ ġ ̵Ų.
				// the beginning.
				newPos = 0;
			} else if (mCurrentElement <= it) {
				// O׷ ʰ mCurrentElement Ϸ ҳ   Ҹ
				// Ű ִٸ ġ  .
				newPos = mCurrentElement - begin(mElements);
			} else {
				// տ     ش ʴ´ٸ
				//  ĭ   ġ ȴ.
				newPos = mCurrentElement - begin(mElements) - 1;
			}

			// Ҹ Ѵ. (ϰ Ѵ.)
			mElements.erase(it);

			// ݺڰ ȿ ¸ ϵ Ѵ.
			mCurrentElement = begin(mElements) + newPos;

			return;
		}
	}
}

template <typename T>
T& RoundRobin<T>::getNext()
{
	//  Ұ  ִ ȮѴ.
	if (mElements.empty()) {
		throw std::out_of_range("No elements in the list");
	}

	//  ( ) ϵ صд.
	auto& toReturn = *mCurrentElement;

	// ݺڸ    (modulo, )  ̿Ͽ Ų.
	++mCurrentElement;
	if (mCurrentElement == end(mElements)) {
		mCurrentElement = begin(mElements);
	}

	// ҿ  ۷ Ѵ.
	return toReturn;
}
