#include "NameDB.h"
#include <stdexcept>
#include <fstream>

using namespace std;

// Ͽ  ̸ ͺ̽ Ѵ.
// ͺ̽ ̸/   vector Ѵ.
//  ׸񸶴 ̸  ̸  Ϳ  Ƚ  ִ.
NameDB::NameDB(string_view nameFile)
{
	//    ߻ߴ ȮѴ.
	ifstream inputFile(nameFile.data());
	if (!inputFile) {
		throw invalid_argument("Unable to open file");
	}

	// ̸   ϳ д´.
	string name;
	while (inputFile >> name) {
		// ־ ̸ ͺ̽ ̹ ִ ȮѴ.
		if (nameExists(name)) {
			// ־ ̸ ͺ̽ ִٸ Ƚ Ѵ.
			incrementNameCount(name);
		} else {
			// ͺ̽ ̸ ٸ  ߰ϰ Ƚ 1 Ѵ.
			addNewName(name);
		}
	}
}

// ͺ̽ ̸ ִٸ true ϰ, ׷ ʴٸ false Ѵ.
bool NameDB::nameExists(string_view name) const
{
	// ̸  Ϳ   鼭 ־ ̸ ˻Ѵ.
	for (auto& entry : mNames) {
		if (entry.first == name) {
			return true;
		}
	}
	return false;
}

//  (Precondition): ̸  Ϳ ־ ̸ ؾ Ѵ.
//  (Postcondition):  ̸  Ƚ ϳ Ų.
void NameDB::incrementNameCount(string_view name)
{
	for (auto& entry : mNames) {
		if (entry.first == name) {
			entry.second++;
			return;
		}
	}
}

// ͺ̽  ̸ ߰Ѵ.
void NameDB::addNewName(string_view name)
{
	mNames.push_back(make_pair(name.data(), 1));
}

// ̸  Ѵ.
//  ־ ̸  Ż  ȸѴ.
// ׷   ̸  ݺ 鼭
// ־ ̸   ̸    Ѵ.
int NameDB::getNameRank(string_view name) const
{
	// getAbsoluteNumber() ޼ óѴ.
	int num = getAbsoluteNumber(name);

	// ̸ ãҴ ȮѴ.
	if (num == -1) {
		return -1;
	}

	// ־ ̸   ̸ Ϳ  ã´.
	// ־ ̸   ̸ ٸ  ̸ 1 .
	// ־ ̸ 󵵰  ̸  1 Ѵ.
	int rank = 1;
	for (auto& entry : mNames) {
		if (entry.second > num) {
			rank++;
		}
	}

	return rank;
}

// ־ ̸  Ѵ.
int NameDB::getAbsoluteNumber(string_view name) const
{
	for (auto& entry : mNames) {
		if (entry.first == name) {
			return entry.second;
		}
	}
	return -1;
}
