#include "NameDB.h"
#include <stdexcept>
#include <fstream>

using namespace std;

// Ͽ  ̸ ͺ̽ Ѵ.
//  ͺ̽ ̸ 󵵿  map Ѵ.
NameDB::NameDB(string_view nameFile)
{
	//    ߻ߴ ȮѴ.
	ifstream inputFile(nameFile.data());
	if (!inputFile) {
		throw invalid_argument("Unable to open file");
	}

	// ̸   ϳ д´.
	string name;
	while (inputFile >> name) {
		// ־ ̸ ͺ̽ ̹ ִ ȮѴ.
		if (!nameExistsAndIncrement(name)) {
			// ־ ̸ ͺ̽ ̹ ִٸ  ϳ Ű   ǳʶڴ.
			//  Ͽ Դٸ ͺ̽  ̸̶ ̹Ƿ
			// ̸ ߰ϰ  ϳ Ų.
			addNewName(name);
		}
	}
}

// ͺ̽ ̸ ִٸ true ϰ, ׷ ʴٸ false Ѵ.
// ͺ̽ ̸ ߰ߴٸ  ϳ Ų.
bool NameDB::nameExistsAndIncrement(string_view name)
{
	// ־ ̸ ʿ ã´.
	auto res = mNames.find(name.data());
	if (res != end(mNames)) {
		res->second++;
		return true;
	}
	return false;
}

// ͺ̽ ̸  ߰Ѵ.
void NameDB::addNewName(string_view name)
{
	mNames[name.data()] = 1;
}

// ־ ̸  Ѵ.
//  ־ ̸  Ʊ  Ѵ.
// ׷   ̸   鼭  ̸   ̸   .
//     Ѵ.
int NameDB::getNameRank(string_view name) const
{
	int num = getAbsoluteNumber(name);

	// ̸ ãҴ ȮѴ.
	if (num == -1) {
		return -1;
	}

	// ʿ ִ ̸ ߿  ̸   ̸  .
	// ׷ ̸ ٸ  ̸ 1. 
	//  ̸   ̸    ̸  1 Ѵ.
	int rank = 1;
	for (auto& entry : mNames) {
		if (entry.second > num) {
			rank++;
		}
	}

	return rank;
}

//  ̸  Ѵ.
int NameDB::getAbsoluteNumber(string_view name) const
{
	auto res = mNames.find(name.data());
	if (res != end(mNames)) {
		return res->second;
	}

	return -1;
}
